/*************************************************
*           BK Emulator v3.8 for Windows         *
*************************************************/

/*
File: ScriptRunner.cpp
Version: 1.0.0
Written by: Yuriy Kalmykov <kalmykov@stoik.com>
    Copyright (c) 2002-2004 Yuriy Kalmykov

    BK Emulator is a program emulated hardware environment for running
code for BK 0010(01) in different configurations.

    This code may be used in compiled form in any way you desire.
This file or it's parts can't be redistributed without the authors
written consent, but can be modified for your private needs.
    Providing that this notice and the authors name and all copyright
notices remains intact.

    Please, an email me to know how you are using it and where. You can
ask me for any information about this below code or any attendant
knowledge.

    This file is provided "as is" with no expressed or implied warranty.
The author accepts no liability for any damage or loss of business that
this product may cause.
*/


// ScriptRunner.cpp: implementation of the CScriptRunner class.
//


#include "stdafx.h"
#include "ScriptRunner.h"
#include "Defines.h"
#include "Board.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction


CScriptRunner::CScriptRunner() :
	m_pChip(NULL),
	m_lpszAscii(NULL),
	m_nScriptLinePos(0),
	m_nScriptCurrTick(0),
	m_fScriptStartDelay(SCRIPT_START_DELAY),
	m_bRus(FALSE)
{
}

CScriptRunner::~CScriptRunner()
{
	//SetScriptPath (_T(""), _T(""));
}


void CScriptRunner::SetScriptPath(const CString &strScriptPath, const CString &strScriptFileName)
{
	if (m_fileScript.m_pStream)
	{
		m_fileScript.Close();
	}

	m_strScriptsPath = strScriptPath;
	m_strScriptFileName = strScriptFileName;
	m_strScriptLine = _T("");
}


BOOL CScriptRunner::RunScript()
{
	ASSERT(m_pChip);

	if (!m_pChip) // Если нету эмулируемого устройства, выйдем с ошибкой
	{
		return FALSE;
	}

	if (m_strScriptFileName.IsEmpty())
	{
		return FALSE;    // Если скрипт не задан, выйдем с ошибкой
	}

	if (!m_fileScript.m_pStream)
	{
		CString ofn = m_strScriptsPath + m_strScriptFileName;

		// если файл не открыт, откроем его
		if (!m_fileScript.Open(ofn, CFile::modeRead))
		{
			// Если файл скрипта не открывается, то реинициализируем обработчик
			// и выйдем с ошибкой
			m_strScriptFileName = _T("");
			return FALSE;
		}

		// Если скрипт открылся, инициализируем переменные
		m_strScriptLine = _T("");
		m_nScriptLinePos = 0;
		m_nScriptCurrTick = GetTickCount(); // Запускаем таймер
	}

	// Если скрипт открыт и всё в порядке
	// Ждём определённое время перед запуском скрипта
	if ((double)(GetTickCount() - m_nScriptCurrTick) / 1000.0 < m_fScriptStartDelay)
	{
		return TRUE;
	}

	if (m_nScriptLinePos >= m_strScriptLine.GetLength())
	{
		// Если дошли до конца текущей строки,
		// почитаем следующую
		m_nScriptLinePos = 0;
		SAFE_DELETE_ARRAY(m_lpszAscii);

		if (!m_fileScript.ReadString(m_strScriptLine))
		{
			// Если строки закончились,
			// закроем файл и переинициализируем переменные
			SetScriptPath(_T(""), _T(""));
			return FALSE;
		}

		m_strScriptLine += _T('\n'); // добавим перевод каретки в конец строки
		int sizeOfString = (m_strScriptLine.GetLength() + 1);
		m_lpszAscii = new char[sizeOfString];
		WideCharToMultiByte(CP_ACP, 0, m_strScriptLine, -1, (LPSTR)m_lpszAscii, sizeOfString, NULL, NULL);
	}

	if (!m_strScriptLine.IsEmpty())
	{
		// Если строка не пуста
		// Получим текущее состояние регистра
		WORD reg177660 = m_pChip->m_reg177660;
		WORD psw = m_pChip->GetPSW();

		// Передадим новый символ только если регистр БК 177660 готов
		// т.е. ждём, пока БК прочтёт следующий код из 177662
		if ((reg177660 & 0200) == 0 && (psw & PSW_P) == 0)
		{
			ParseNextChar(m_lpszAscii[m_nScriptLinePos++]);
		}
	}

	return TRUE;
}


void CScriptRunner::ParseNextChar(unsigned char ansi_ch)
{
	if (ansi_ch == '|')
	{
		//это снова надо установить задержку
		m_nScriptCurrTick = GetTickCount();
		return;
	}
	else if (ansi_ch >= 192 && !m_bRus)
	{
		m_nScriptLinePos--;
		ansi_ch = BKKEY_RUS;
		m_bRus = TRUE;
	}
	else if (ansi_ch >= 32 && ansi_ch <= 127 && m_bRus)
	{
		m_nScriptLinePos--;
		ansi_ch = BKKEY_LAT;
		m_bRus = FALSE;
	}

	SendNewCharToBK(ansi_ch);
}


void CScriptRunner::SendNewCharToBK(unsigned char ch)
{
	ANSIToBK(ch);  // Конвертируем символ в БКшную кодировку
	// Получим текущее состояние регистра
	WORD reg177660 = m_pChip->m_reg177660;
	// Установим состояние готовности в 177660
	m_pChip->m_reg177660 |= 0200;
	// Отправим код символа в 177662
	m_pChip->m_reg177662in = ch & 0177;
	// Установим флаг нажатия клавиши в 177716
	m_pChip->m_reg177716in &= ~0100;
	//if (!m_bIsAr2Press)
	m_pChip->KeyboardInterrupt(INTERRUPT_60);
	//else
	//  m_pChip->KeyboardInterrupt (INTERRUPT_274);
}
